package com.nmmedit.glide;

import android.content.Context;
import android.graphics.Bitmap;
import android.util.Log;

import com.bumptech.glide.Glide;
import com.bumptech.glide.GlideBuilder;
import com.bumptech.glide.Registry;
import com.bumptech.glide.annotation.GlideModule;
import com.bumptech.glide.module.AppGlideModule;
import com.nmmedit.glide.avif.ByteBufferAvifDecoder;
import com.nmmedit.glide.avif.ByteBufferAvifSequenceDecoder;
import com.nmmedit.glide.avif.StreamAvifDecoder;
import com.nmmedit.glide.avif.StreamAvifSequenceDecoder;

import java.io.InputStream;
import java.nio.ByteBuffer;

import androidx.annotation.NonNull;
import libavif.AvifSequenceDrawable;

/**
 * Created by mao on 17-3-6.
 */

@GlideModule
public class MyGlideModule extends AppGlideModule
{
    @Override
    public void applyOptions(@NonNull Context context, @NonNull GlideBuilder builder)
    {
        builder.setLogLevel(Log.ERROR);
    }

    @Override
    public boolean isManifestParsingEnabled()
    {
        return false;
    }

    @Override
    public void registerComponents(@NonNull Context context, @NonNull Glide glide, @NonNull Registry registry)
    {
        registry.prepend(InputStream.class, AvifSequenceDrawable.class,
                         new StreamAvifSequenceDecoder(glide.getBitmapPool(), glide.getArrayPool()));
        registry.prepend(ByteBuffer.class, AvifSequenceDrawable.class,
                         new ByteBufferAvifSequenceDecoder(glide.getBitmapPool()));

        registry.prepend(Registry.BUCKET_BITMAP, InputStream.class, Bitmap.class,
                         new StreamAvifDecoder(glide.getBitmapPool(), glide.getArrayPool()));
        registry.prepend(Registry.BUCKET_BITMAP, ByteBuffer.class, Bitmap.class,
                         new ByteBufferAvifDecoder(glide.getBitmapPool()));
    }
}
